% joint data for GPP1

% total file
clear all;
load ftna1.txt;
load ftna2.txt;
load ftna3.txt;
ftna = [ftna1' ftna2' ftna3']';
clear fnta1 ftna2 ftna3;
load ahtotal.txt;
load f2000.txt;
%load f2000s.txt;

a0 = 21; % # vars before y_org
% adding quarterly TNA
for i=1:size(ahtotal,1),
    id1 = find(ftna(:,1)==ahtotal(i,1) & ftna(:,2)==ahtotal(i,2)); % same fund and year
    if size(id1,1)==1, % & ftna(id1,6)==ahtotal(i,a0),
        if isnan(ftna(id1,6))==0 & ftna(id1,6)~=ahtotal(i,a0),
            disp(ahtotal(i,1:2));
        end;
        ahtotal(i,a0-3:a0) = ftna(id1,3:6);
    end;
end;

anum1 = size(ahtotal,1); % # funds in 1976-1999
anum2 = size(f2000,1); % # funds in 1999-2003
ahtotal(anum1+1:anum1+anum2,:) = [f2000(:,[1 2 6 7 9:21 24 27 30 33 3]) repmat(1,anum2,1) repmat(NaN,anum2,3) f2000(:,4:5) repmat(NaN,anum2,1)];

% yinc minc class MRobj MRstyle indicator from ahtotal
for i=1+anum1:anum1+anum2,
    if i>1+anum1 & ahtotal(i,1)==ahtotal(i-1,1) & sum(isnan(ahtotal(i-1,a0+1:a0+2)))==0,
        ahtotal(i,a0+1:a0+5) = ahtotal(i-1,a0+1:a0+5);
        ahtotal(i,end) = ahtotal(i-1,end);
    else
        ix = find(ahtotal(1:anum1,1)==ahtotal(i,1));
        if length(ix)>0,
            ahtotal(i,a0+1:a0+5) = ahtotal(ix(end),a0+1:a0+5);
            ahtotal(i,end) = ahtotal(ix(end),end);
        end;
    end;
end;

% correcting the bug: y_org=0 for 2003
idx = find(ahtotal(:,a0+1)==0);
for i=1:length(idx),
    ix = find(ahtotal(:,1)==ahtotal(idx(i),1));
    if length(ix)>1,
        ahtotal(idx(i),a0+1) = ahtotal(ix(1),a0+1);
    elseif length(ix)==1,
        ahtotal(idx(i),a0+1) = ahtotal(ix,2);
    end;
end;
idx = find(ahtotal(:,a0+1)==0);
if length(idx)>0,
    disp('the bug with y_org=0 remains');
end;

ahtotal = sortrows(ahtotal,[1 2]);
% correcting yinc minc
% icount = 0;
% load flist.txt; % # y_start m_start (data)
% for i=1:size(flist,1),
%     ix = find(ahtotal(:,1)==flist(i,1));
%     if length(ix)>0 & ahtotal(ix(1),a0+1) > flist(i,2),
%         ahtotal(ix,a0+1:a0+2) = repmat(length(ix),1,flist(i,2:3));
%         icount = icount + 1;
%     end;
% end;
% disp('# funds with corrected starting date:');
% disp(icount);

% class stats
idx = find(ahtotal(:,a0+3)==1);
disp('% Div Equity funds:');
disp([size(idx,1)/size(ahtotal,1) size(idx,1) size(ahtotal,1)]);
%ahtotsl = ahtotal(idx,:);

%ahtotal = sortrows(ahtotal,[2 1]);
save etotal.txt ahtotal -ASCII -TABS;



% correcting the bug with turn=0 for funds after 1999
load fturn2000.txt;
load etotal.txt;
idx = find(etotal(:,3)==0 & etotal(:,2)>1999 & etotal(:,2)<2003);
disp(length(idx));
for i=1:length(idx),
    ix = find(fturn2000(:,1)==etotal(idx(i),1) & fturn2000(:,2)==etotal(idx(i),2));
    if length(ix)==1,
        etotal(idx(i),3) = fturn2000(ix,3);
    end;
end;
idx = find(etotal(:,3)==0 & etotal(:,2)>1999 & etotal(:,2)<2003);
if length(idx)>0,
    disp('the bug with turn=0 remains');
    disp(length(idx));
end;
save etotal.txt etotal -ASCII -TABS;


% correcting the bug with y_inc=0 for funds after 1999
load etotal.txt;
load flist.txt;
a0=21;
idx = find(etotal(:,a0+1)<1921 | isnan(etotal(:,a0+1))==1);
disp(length(idx));
for i=1:length(idx),
    ix = find(flist(:,1)==etotal(idx(i),1));
    if length(ix)==1,
        etotal(idx(i),a0+1:a0+2) = flist(ix,2:3);
    end;
end;
idx = find(etotal(:,a0+1)<1921);
disp(length(idx));
save etotal.txt etotal -ASCII -TABS;

 
   